/*******************************************************************************
 * Copyright (c) 2005 INRIA.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Marcos Didonet Del Fabro - initial API and implementation
 *    Guillaume Gueltas
 *******************************************************************************/


package org.eclipse.gmt.weaver.extension.providers;

import java.util.Collection;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.gmt.weaver.editors.interfaces.IWeaverItemProvider;


/**
 * ItemProvider base extension
 * @since 1.0
 */

public class MatchModelItemProvider extends WElementItemProvider 
	implements      
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource, 
		IWeaverItemProvider
		
    {
    /**
     * This creates a base extension item provider
     */
    public MatchModelItemProvider(){
        super();
    }
    
    protected void setChildrenConstraints(EObject parent, EObject child, Object afectedObj, Collection deleteList){
    	//models cant have links and association ends as child
    	if (  isInstanceOf(parent,"WModel") && (
    			isInstanceOf(child,"WLinkEnd")
    			|| isInstanceOf(child,"WAssociationEnd") ) )
    		deleteList.add(afectedObj);

    	//ref and model elements cannot be created by menu
    	if (isInstanceOf(child,"WModelRef") || 
    			isInstanceOf(child,"WElementRef")
    			|| isInstanceOf(child,"WRef")
    			|| isInstanceOf(child,"WModel"))            
    		deleteList.add(afectedObj);

    	if (  isInstanceOf(child,"WAssociation"))
    		deleteList.add(afectedObj);
    }

            
}



