/*******************************************************************************
 * Copyright (c) 2005 INRIA.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Marcos Didonet Del Fabro - initial API and implementation
 *******************************************************************************/


package org.eclipse.gmt.weaver.extension.providers;

import java.text.DecimalFormat;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.gmt.weaver.editors.interfaces.IWeaverItemProvider;


/**
 * ItemProvider base extension
 * @since 1.0
 */

public class WLinkItemProvider extends WElementItemProvider 
	implements      
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource, 
		IWeaverItemProvider
		
    {
    /**
     * This creates a base extension item provider
     */
    public WLinkItemProvider(){
        super();
    }
    /* (non-Javadoc)
     * @see org.eclipse.emf.edit.provider.ItemProviderAdapter#getText(java.lang.Object)
     */
    public String getText(Object object) {    	
    	String str = super.getText(object);
    	//sets the similarity in the side of the class name
    	if (object instanceof EObject){
    		EObject eObj = (EObject) object;
    		EStructuralFeature feature = eObj.eClass().getEStructuralFeature("similarity");
    		if (feature != null) {
    			Object obj = eObj.eGet(feature);
    			if (obj != null) 
    				if (obj instanceof Double) {        					
    					double d = ((Double)obj).doubleValue();
    					DecimalFormat df = new DecimalFormat("#.###");    					
    					str = str +" sim: " +df.format(d);
    				}
    				
    		}
    	}
    	return str;
    }
            
}



