/*******************************************************************************
 * Copyright (c) 2005 INRIA.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Marcos Didonet Del Fabro - initial API and implementation
 *    Guillaume Gueltas
 *******************************************************************************/


package org.eclipse.gmt.weaver.extension.providers;


import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITableItemLabelProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ReflectiveItemProviderAdapterFactory;


/**
 * An extensible adapter factory for the model weaver
 * It allows to creates the adapter for the current object. 
 * Every object might have a different adapter if needed 
 * @since 1.0
 */

public class WovenModelsAdapterFactory extends ReflectiveItemProviderAdapterFactory {    

    
    /**
     * This creates a new weaver extension manager
     * @param we the Weaver Extension Manager
     */
    public WovenModelsAdapterFactory() {
    	
    	reflectiveItemProviderAdapter = new WovenElementItemProvider(this);
        supportedTypes.clear();

        supportedTypes.add(IItemLabelProvider.class);
        supportedTypes.add(ITreeItemContentProvider.class);
        supportedTypes.add(IItemPropertySource.class);
        supportedTypes.add(IStructuredItemContentProvider.class);
        supportedTypes.add(IEditingDomainItemProvider.class);
        supportedTypes.add(ITableItemLabelProvider.class);       
    }    
              
}
