/*******************************************************************************
 * Copyright (c) 2005 INRIA.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * * Contributors:
 *    Marcos Didonet Del Fabro - initial API and implementation
 *    Guillaume Gueltas
******************************************************************************/


package org.eclipse.gmt.weaver.extension.providers;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.gmt.weaver.providers.IIdentifierAdapter;
import org.eclipse.gmt.weaver.providers.XMIIdentifierAdapter;


/**
 * ItemProvider extension with XMI ID generation mechanism
 */

public class XMIElementRefItemProvider extends WElementItemProvider  implements IIdentifierAdapter {

	public XMIElementRefItemProvider(){
		super();		
		this.adapter = new XMIIdentifierAdapter(null);
	}
	
	private IIdentifierAdapter adapter;
	/* (non-Javadoc)
	 * @see org.eclipse.gmt.weaver.providers.IIdentifierAdapter#setID(java.lang.Object)
	 */
	public void setID(Object obj) {
		adapter.setID(obj);
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.gmt.weaver.providers.IIdentifierAdapter#getID()
	 */
	public Object getID() {		
		return adapter.getID();
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.gmt.weaver.providers.IIdentifierAdapter#getTarget()
	 */
	public Notifier getTarget() {		
		return adapter.getTarget();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gmt.weaver.providers.IIdentifierAdapter#setTarget(org.eclipse.emf.common.notify.Notifier)
	 */
	public void setTarget(Notifier source) {
		adapter.setTarget(source);		
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.emf.common.notify.Adapter#notifyChanged(org.eclipse.emf.common.notify.Notification)
	 */
	public void notifyChanged(Notification notification){
		super.notifyChanged(notification);
	}
}



