/*******************************************************************************
 * Copyright (c) 2006 INRIA.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Marcos Didonet Del Fabro - initial API and implementation
 *
 *******************************************************************************/

package org.eclipse.gmt.weaver.qatl;

import java.util.Collection;

import org.eclipse.emf.ecore.EObject;

/**
 * @since AMW2006
 * 
 */

public class RuleItemProvider extends TransformationItemProvider {

	public RuleItemProvider() {
		super();
	}
	
	/**
     * sets constraints on the returned children objects and adds then into a deleteList
     * @param parent the current parent obj
     * @param child the child
     * @param afectedObj an associated object (usually is the child itself) 
     * @param deleteList the constrained object that will be deleted
     */
    protected void setChildrenConstraints(EObject parent, EObject child, Object afectedObj, Collection deleteList){
        //models cant have links and association ends as child
    	super.setChildrenConstraints(parent, child, afectedObj, deleteList);
        if (
        	isInstanceOf(parent,"Rule") && isInstanceOf(child,"WLink") && !child.eClass().getName().equals("Rule")
        )
       		deleteList.add(afectedObj);
    }
    

}
