/*******************************************************************************
 * Copyright (c) 2006 INRIA.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *******************************************************************************/

package org.eclipse.gmt.weaver.transformation.config;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
* @author - Marcos Didonet Del Fabro (LINA Labs, INRIA Group)<br>
* @since 1.0
*/


public abstract class TransformationConfig {
	public String plugin;
	public String transformation;
	public String suffix;
	public String description;
	public String category;
	public List bindings;
	public String type;
	public boolean hasConfigurationModel;
	
	public Object clone() {
	
		TransformationConfig tc = new TransformationConfig () {}; // this is an anonymous class   	
		tc.type = type;
		tc.plugin = plugin;
		tc.transformation = transformation;
		tc.suffix = suffix;
		tc.description = description;
		tc.category = category;
		tc.bindings = new ArrayList();
		tc.hasConfigurationModel = false;
				
		for (Iterator bindList = bindings.iterator(); bindList.hasNext();) {
			TBinding element = (TBinding) bindList.next();
			TBinding b = new TBinding () {};
			b.weavingReference = element.weavingReference;
			b.header = element.header;
			b.description = element.description;
			b.metamodelPath = element.metamodelPath;
			b.metamodelHeader = element.metamodelHeader;
			b.path = element.path;
			b.isExtraBinding = element.isExtraBinding;
			tc.bindings.add(b);						
			
		}
		return tc;
	}
}

