lexer grammar KM3_ANTLR3;
@members {

	private void newline() {}

	public org.eclipse.gmt.tcs.injector.TCSRuntime ei = null;

	public void displayRecognitionError(String[] tokenNames, RecognitionException e) {
		ei.reportError((Exception)e);
	}

	public Token emit() {
		org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken ret = null;

		ret = new org.eclipse.gmt.tcs.injector.wrappers.antlr3.ANTLR3LocationToken(input, type, channel, tokenStartCharIndex, getCharIndex()-1);
		ret.setLine(tokenStartLine);
		ret.setText(text);
	  	ret.setCharPositionInLine(tokenStartCharPositionInLine);
		ret.setEndLine(getLine());
		ret.setEndColumn(getCharPositionInLine());
		emit(ret);

		return ret;
	}

}
@header {package org.eclipse.gmt.tcs.injector;}

T42 : 'package' ;
T43 : 'datatype' ;
T44 : 'abstract' ;
T45 : 'class' ;
T46 : 'extends' ;
T47 : 'reference' ;
T48 : 'container' ;
T49 : 'subsets' ;
T50 : 'oppositeOf' ;
T51 : 'attribute' ;
T52 : 'unique' ;
T53 : 'operation' ;
T54 : 'enumeration' ;
T55 : 'literal' ;
T56 : 'ordered' ;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 240
NL
	:	(	'\r' '\n'
		|	'\n' '\r'	//Improbable
		|	'\r'
		|	'\n'
		)
	{newline();}
	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 249
WS
	:	(	' '
		|	'\t'
		)
	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 255
fragment
DIGIT
	:	'0'..'9'
	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 260
fragment
ALPHA
	:	'a'..'z'
	|	'A'..'Z'
	|	'_'
	//For Unicode compatibility (from 0000 to 00ff)
	|	'\u00C0' .. '\u00D6'
	|	'\u00D8' .. '\u00F6'
	|	'\u00F8' .. '\u00FF'
	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 271
fragment
SNAME
//	options {
//		testLiterals = true;
//	}
	:	(ALPHA) (ALPHA | DIGIT)*
;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 279
NAME
	:	(
			SNAME
//			s:SNAME {if(s.getType() != SNAME) $setType(s.getType());}
		|	'"'!
			(	ESC
			|	'\n' {newline();}
			|	~('\\'|'\"'|'\n')
			)*
			'"'!
			{setText(ei.unescapeString(getText(), 1));}
		)
	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 293
INT
	:	(DIGIT)+
//		(('.' DIGIT)=> '.' (DIGIT)+ {$setType(FLOAT);})?
	;

	// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 298
FLOAT	:	DIGIT+ '.' DIGIT*	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 300
fragment
ESC
	:	'\\'!
		(	'n' {setText("\n");}
		|	'r' {setText("\r");}
		|	't' {setText("\t");}
		|	'b' {setText("\b");}
		|	'f' {setText("\f");}
		|	'"' {setText("\"");}
		|	'\'' {setText("\'");}
		|	'\\' {setText("\\");}
		|	(
				('0'..'3')
				(
//					options {
//						warnWhenFollowAmbig = false;
//					}
				:	('0'..'7')
					(
//						options {
//							warnWhenFollowAmbig = false;
//						}
					:	'0'..'7'
					)?
				)?
			|	('4'..'7')
				(
//					options {
//						warnWhenFollowAmbig = false;
//					}
				:	('0'..'7')
				)?
			)
				{
					String s = getText();
					int i;
					int ret = 0;
					String ans;
					for (i=0; i<s.length(); ++i)
						ret = ret*8 + s.charAt(i) - '0';
					ans = String.valueOf((char) ret);
					setText(ans);
				}
		)
	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 346
STRING
	:	'\''!
		(	ESC
		|	'\n' {newline();}
		|	~('\\'|'\''|'\n')
		)*
		'\''!
			{setText(ei.unescapeString(getText(), 1));}
	;

	

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 358
LSQUARE @init {}
	:	'['
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 366
RSQUARE @init {}
	:	']'
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 374
EXCL @init {}
	:	'!'
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 382
COMA @init {}
	:	','
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 390
LPAREN @init {}
	:	'('
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 398
RPAREN @init {}
	:	')'
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 406
LCURLY @init {}
	:	'{'
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 414
RCURLY @init {}
	:	'}'
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 422
SEMI @init {}
	:	';'
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 430
COLON @init {}
	:	':'
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 438
COLONS @init {}
	:	'::'
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 446
PIPE @init {}
	:	'|'
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 454
SHARP @init {}
	:	'#'
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 462
QMARK @init {}
	:	'?'
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 470
POINT @init {}
	:	'.'
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 478
RARROW @init {}
	:	'->'
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 486
MINUS @init {}
	:	'-'
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 494
STAR @init {}
	:	'*'
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 502
SLASH @init {}
	:	'/'
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 510
PLUS @init {}
	:	'+'
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 518
EQ @init {}
	:	'='
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 526
GT @init {}
	:	'>'
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 534
LT @init {}
	:	'<'
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 542
GE @init {}
	:	'>='
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 550
LE @init {}
	:	'<='
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 558
NE @init {}
	:	'<>'
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 566
LARROW @init {}
	:	'<-'
        {
            
        }

	;

// $ANTLR src "C:\Documents and Settings\mddfabro\My Documents\workspaces\ganimede_runtime\KM3-2005\Syntax\KM3_ANTLR3.g" 574
COMMENT @init {}
	:	(('--' (~('\r'| '\n'))*))
        {
            
        }

	;
