/*******************************************************************************
 * Copyright (c) 2005 INRIA.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Marcos Didonet Del Fabro - initial API and implementation
 *    Guillaume Gueltas
 *******************************************************************************/


package org.eclipse.gmt.weaver.editors.interfaces;

import java.util.List;

import org.eclipse.emf.ecore.EObject;

/**
 * Interface for listening a selection changing event 
 * Receives a URI of an EObject
 * @since 1.0
 */
public interface IWSelectionChangedListener {
    /**
     * selects all objects that are represented by the URI's list passed as parameters
     */
    public void selectEObject(List objectIDs, List modelURIs, EObject currentWeaverSelection);     
}
