/*******************************************************************************
 * Copyright (c) 2005 INRIA.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Marcos Didonet Del Fabro - initial API and implementation
 *    Guillaume Gueltas
 *******************************************************************************/


package org.eclipse.gmt.weaver.editors.interfaces;

import java.util.List;

import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.gmt.weaver.core.WeaverModelManager;

/**
 * Interface initialize metamodel extension
 * @since 1.0
 */
public interface IWeaverInitializer {
	/**
	 * Initializes resource with modelrefs 
	 * @param manager
	 * @param editingDomain
	 * @param wModelName
	 * @param wModelRefNames
	 * @param wReferenceNames
	 * @param isNew
	 */
    public void initWeaverMetamodel(WeaverModelManager manager, EditingDomain editingDomain, 
    		String wModelName, List wModelRefClassNames, List wReferenceNames, 
    		List wModelRef_name, List wModelRef_ref,  
    		boolean isNew);    
}
