/*******************************************************************************
 * Copyright (c) 2005 INRIA.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Marcos Didonet Del Fabro - initial API and implementation
 *    Guillaume Gueltas
 *******************************************************************************/


package org.eclipse.gmt.weaver.editors.interfaces;

import java.util.Map;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.AdapterFactory;

/**
 * Interface for Item Provider
 * @since 1.0
 */
public interface IWeaverItemProvider extends Adapter {
    
	/**
	 * Sets the adapter factory
	 * @param adapterFactory
	 */
	public void setAdapterFactory(AdapterFactory adapterFactory);
	/**
	 * Sets the map of icons in the itemProvider
	 * @param icon the string relative path or null
	 */
	public void setIconMap(Map icons);
}
