/*******************************************************************************
 * Copyright (c) 2005 INRIA.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Marcos Didonet Del Fabro - initial API and implementation
 *    Guillaume Gueltas
 *******************************************************************************/


package org.eclipse.gmt.weaver.editors.interfaces;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.jface.action.IMenuManager;

/**
 * Interface for call editor contributor
 * @since 1.0
 */
public interface IWeaverMenuAdapter {
    /**
     * creates a list with sub menu actions associated with this eObj 
     * @param eObj
     */
    public void createActions(EObject eObj);
    /**
     * populates the menu with the private actions into the parent menu specified 
     * @param parentMenu
     */
    public void populateMenuAboutToShow(IMenuManager parentMenu);
    
}
