/*******************************************************************************
 * Copyright (c) 2005 INRIA.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Marcos Didonet Del Fabro - initial API and implementation
 *    Guillaume Gueltas
 *******************************************************************************/

package org.eclipse.gmt.weaver.plugin;

/**
 * Class for constants of weawer plugin 
 * @since 1.0 
 */
public class WeaverConstant {
	//formats xmi(ecore), km3 or amw  
	static final public int XMI = 1;
	static final public int KM3 = 2;
	static final public int AMW = 3;
	
	//reference names
	static final public String ELEMENT_REF_FEATURE = "ownedElementRef";
	static final public String MODEL_REF_FEATURE = "modelRef";	
	
	static final public String MODEL_REF_ELEMENT = "WModelRef";	
	static final public String MOF = "MOF";
	
	//identification of the resource
	static final public String RESOURCE_STRING = "platform:/resource";
	static final public String ID_TOKEN = "_";
	
	//extensions
	static final public String PROPERTY_FILE_EXT = "amw.prop";		
	static final public String PROPERTY_LAST_EXT = "prop";
	static final public String FILE_EXT = "amw";

	//extension points
	static final public int METAMODEL_EXT =0;
    static final public String METAMODEL_EXT_ID = "org.eclipse.gmt.weaver.metamodelExtensionID";
    static final public int  ITEM_PROVIDER_EXT = 1;
    static final public String ITEM_PROVIDER_EXT_ID = "org.eclipse.gmt.weaver.itemProviderID";
    public static final int WOVEN_PANEL_EXT = 2;	
	public static final String WOVEN_PANEL_EXT_ID = "org.eclipse.gmt.weaver.wovenPanelID";
	public static final int WEAVING_PANEL_EXT = 3;	
	public static final String WEAVING_PANEL_EXT_ID = "org.eclipse.gmt.weaver.weavingPanelID";
	public static final String WEAVING_FILE = "mwcore.km3";
	static final public int INITIALIZE_EXT =4;
    static final public String INITIALIZE_EXT_ID = "org.eclipse.gmt.weaver.initializeExtensionID";    

    static final public String MODEL_TYPE = "1";
    static final public String METAMODEL_TYPE = "2";
    
    static final public String ID_SUFFIX = "Id";
	//prefix for generating welementref names
	static final public String REF_PREFIX = "ref_";
	
	//model handlers - adapters
	static final public String EMF_VM = "EMF-specific VM";
	static final public String ATL = "ATL";
	public static final String EMF = "EMF";

}
