/*******************************************************************************
 * Copyright (c) 2005 INRIA.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Marcos Didonet Del Fabro - initial API and implementation
 *    Guillaume Gueltas
 *******************************************************************************/


package org.eclipse.gmt.weaver.providers;

import org.eclipse.emf.common.notify.Adapter;

/**
 * 
 * Interface that defines methods for ID generation
 * @since 1.1
 */
public interface IIdentifierAdapter extends Adapter {
	
			
	/**
	 * sets the id of the current object calculating from the obj
	 * @param obj the object to do the calculations (is is commonly a String)
	 */
	public void setID(Object obj);

	/**
	 * gets the id of the current object
	 * @return the object ID
	 */
	public Object getID();

}
